// channeld.c

#include <ansi.h>
#include <net/dns.h>

void create()
{
	seteuid(getuid());	// This is required to pass intermud access check.
}

mapping channels = ([
	"sys":	([	"msg_speak": HIB "itΡj%sR%s\n" NOR, "wiz_only": 1 ]),
	"wiz":	([	"msg_speak": HIY "iŮvj%sR%s\n" NOR, "wiz_only": 1 ]),
	"gwiz":	([	"msg_speak": HIG "iڧŮvj%sR%s\n" NOR,
				"msg_emote": HIG "iڧŮvj%s %s.\n" NOR,
				"wiz_only": 1, "intermud": GWIZ, "channel": "CREATOR",
				"filter": 1 ]),
	"es":	([	"msg_speak": HIR "iFGơj%sR%s\n" NOR,
				"msg_emote": HIR "iFGơj%s %s.\n" NOR,
				"intermud": GCHANNEL, "channel": "es",
				"filter": (: $1["MUDLIB"]=="Eastern Stories" :) ]),
	"twiz":	([	"msg_speak": HIW "ixWŮvj%sR%s\n" NOR,
				"msg_emote": HIW "ixWŮvj%s %s.\n" NOR,
				"wiz_only":1, "intermud": GCHANNEL, "channel": "twiz",
				"filter": (: $1["HOSTADDRESS"][0..2]=="140" :) ]),
	"chat":	([	"msg_speak": HIC "ij%sR%s\n" NOR ]),
	"rumor":([	"msg_speak": HIM "ij%sR%s\n" NOR,	"anonymous": "YH"	]),
]);

varargs int do_channel(object me, string verb, string arg, int emote)
{
	object *ob;
	string *tuned_ch, who;

	if( !mapp(channels) || undefinedp(channels[verb]) )
		return 0;

	if( userp(me) ) {
		if(channels[verb]["wiz_only"] && !wizardp(me) )
			return 0;

		// If we speaks something in this channel, then must tune it in.
		tuned_ch = me->query("channels");
		if( !pointerp(tuned_ch) )
			me->set("channels", ({ verb }) );
		else if( member_array(verb, tuned_ch)==-1 )
			me->set("channels", tuned_ch + ({ verb }) );
	}

	if( channels[verb]["anonymous"] )
		who = channels[verb]["anonymous"];
	else if( userp(me) || !stringp(who = me->query("channel_id")) )
		who = me->query("name") + "(" + capitalize(me->query("id")) + ")";

	// Ok, now send the message to those people listening us.
	ob = filter_array( users(), "filter_listener", this_object(), channels[verb] );
	if( !arg ) arg = "...";
	message( "channel:" + verb,
		sprintf(channels[verb][emote? "msg_emote" : "msg_speak"], who, arg ), ob );

	if( !undefinedp(channels[verb]["intermud"])
	&&	base_name(me) != channels[verb]["intermud"] )
		channels[verb]["intermud"]->send_msg(
			channels[verb]["channel"], me->query("id"), me->name(1), arg, 0,
			channels[verb]["filter"] );

	return 1;
}

int filter_listener(object ppl, mapping ch)
{
	// Don't bother those in the login limbo.
	if( !environment(ppl) ) return 0;
	
	if( ch["wiz_only"] ) return wizardp(ppl);
	return 1;
}

