// rankd.c

#include <ansi.h>

mapping wiz_rank = ([
	"(admin)": 		({ HIW "i    j" NOR, HIW "i   Z j" NOR }),
	"(arch)": 		({ HIY "i    j" NOR, HIY "i   Z j" NOR }),
	"(wizard)": 	({ HIG "i    j" NOR, HIG "i   Z j" NOR }),
	"(apprentice)":	({ HIC "i    j" NOR, HIC "i   Z j" NOR }),
]);

string query_rank(object ob)
{
	if( ob->is_ghost() ) return HIB "i    j" NOR;
	switch(ob->query("gender")) {
	case "k":
		switch(SECURITY_D->get_status(ob)) {
			case "(admin)":			return HIW "i   Z j" NOR;
			case "(arch)":			return HIY "i k   j" NOR;
			case "(wizard)":		return HIG "i ]  k j" NOR;
			case "(apprentice)":	return HIC "i p]k j" NOR;
			default:
				switch(ob->query("class")) {
					case "bonze":		return "i   h j";
					case "taoist":		return "i k  a j";
					case "bandit":		return "i k j";
					case "dancer":		return "i R   j";
					case "scholar":		return "i ~  k j";
					case "officer":		return "i k  x j";
					case "fighter":		return "i kZ j";
					case "swordsman":	return "i kCh j";
					case "alchemist":	return "i   h j";
					case "shaman":		return "i    j";
					default:			return "i    j";
			}
		}
	default:
		switch(SECURITY_D->get_status(ob)) {
			case "(admin)":			return HIW "i    j" NOR;
			case "(arch)":			return HIY "i    j" NOR;
			case "(wizard)":		return HIG "i   v j" NOR;
			case "(apprentice)":	return HIC "iŮvǮ{j" NOR;
			default:
				switch(ob->query("class")) {
					case "bonze":		return "i   H j";
					case "taoist":		return "i D  h j";
					case "bandit":		return "i s   j";
					case "scholar":		return "i    j";
					case "officer":		return "i x  t j";
					case "fighter":		return "i Z   j";
					case "swordsman":	return "i C  h j";
					case "alchemist":	return "i   h j";
					case "shaman":		return "i    j";
					default:			return "i    j";
			}
		}
	}
}

string query_respect(object ob)
{
	int age;
	string str;

	if( stringp(str = ob->query("rank_info/respect")) )
		return str;

	age = ob->query("age");
	switch(ob->query("gender")) {
		case "k":
			switch(ob->query("class")) {
			case "bonze":
				if( age < 18 ) return "pv";
				else return "v";
				break;
			case "taoist":
				if( age < 18 ) return "pPh";
				else return "Ph";
				break;
			default:
				if( age < 18 ) return "phQ";
				else if( age < 50 ) return "hQ";
				else return "CC";
				break;
			}
		case "k":
		default:
			switch(ob->query("class")) {
			case "bonze":
				if( age < 18 ) return "pv";
				else return "jv";
				break;
			case "taoist":
				if( age < 18 ) return "DS";
				else return "D";
				break;
			case "fighter":
			case "swordsman":
				if( age < 18 ) return "pѧ";
				else if( age < 50 ) return "h";
				else return "ѫe";
				break;
			default:
				if( age < 20 ) return "pS";
				else if( age < 50 ) return "ѥS";
				else return "ѷݤl";
				break;
			}
	}
}

string query_rude(object ob)
{
	int age;
	string str;

	if( stringp(str = ob->query("rank_info/rude")) )
		return str;

	age = ob->query("age");
	switch(ob->query("gender")) {
		case "k":
			switch(ob->query("class")) {
			case "bonze":
				return "饧";
				break;
			case "taoist":
				return "k";
				break;
			default:
				if( age < 30 ) return "pH";
				else return "ѤӱC";
				break;
			}
		case "k":
		default:
			switch(ob->query("class")) {
			case "bonze":
				if( age < 50 ) return "rj";
				else return "Ѩrj";
				break;
			case "taoist":
				return "l";
				break;
			default:
				if( age < 20 ) return "pKJ";
				if( age < 50 ) return "";
				else return "ѤǤ";
				break;
			}
	}
}

string query_self(object ob)
{
	int age;
	string str;

	if( stringp(str = ob->query("rank_info/self")) )
		return str;

	age = ob->query("age");
	switch(ob->query("gender")) {
		case "k":
			switch(ob->query("class")) {
			case "bonze":
				if( age < 50 ) return "h";
				else return "ѥ";
				break;
			default:
				if( age < 30 ) return "pkl";
				else return "c";
				break;
			}
		case "k":
		default:
			switch(ob->query("class")) {
			case "bonze":
				if( age < 50 ) return "h";
				else return "ѯ";
				break;
			case "taoist":
				return "hD";
				break;
			default:
				if( age < 50 ) return "bU";
				else return "Yl";
				break;
			}
	}
}

string query_self_rude(object ob)
{
	int age;
	string str;

	if( stringp(str = ob->query("rank_info/self_rude")) )
		return str;

	age = ob->query("age");
	switch(ob->query("gender")) {
		case "k":
			switch(ob->query("class")) {
			case "bonze":
				if( age < 50 ) return "h";
				else return "ѥ";
				break;
			default:
				if( age < 30 ) return "hQ";
				else return "ѮQ";
				break;
			}
		case "k":
		default:
			switch(ob->query("class")) {
			case "bonze":
				if( age < 50 ) return "jM|";
				else return "ѩM|";
				break;
			case "taoist":
				return "sH";
				break;
			default:
				if( age < 50 ) return "jݧ";
				else return "Ѥl";
				break;
			}
	}
}
