// weapond.c

#include <ansi.h>
#include <combat.h>

mapping weapon_actions = ([
	"slash": ([
		"damage_type":	"ζ",
		"action":		"$N$wM٦V$n$l",
		"parry":		20,
		]),
	"slice": ([
		"damage_type":	"",
		"action":		"$N$w$n$lh",
		"dodge":		20,
		]),
	"chop": ([
		"damage_type":	"",
		"action":		"$N$wµ$n$lANLh",
		"parry":		-20,
		]),
	"hack": ([
		"action":		"$NR$wM$n$l@}ì",
		"damage_type":	"",
		"damage":		30,
		"dodge":		30,
		]),
	"thrust": ([
		"damage_type":	"",
		"action":		"$N$w$n$lh",
		"dodge":		15,
		"parry":		-15,
		]),
	"pierce": ([
		"action":		"$N$w$n$la@Ѷ",
		"damage_type":	"",
		"dodge":		-30,
		"parry":		-30,
		]),
	"whip": ([
		"action":		"$NN$w@M$n$lh",
		"damage_type":	"@",
		"dodge":		-20,
		"parry":		30,
		]),
	"impale": ([
		"action":		"$N$w$n$lWLh",
		"damage_type":	"",
		"dodge":		-10,
		"parry":		-10,
		]),
	"bash": ([
		"action":		"$NR$wM$n$lΤO@",
		"damage_type":	"",
		"post_action":	(: call_other, __FILE__, "bash_weapon" :),
		]),
	"crush": ([
		"action":		"$N|_$wM$n$lY{U",
		"damage_type":	"",
		"post_action":	(: call_other, __FILE__, "bash_weapon" :),
		]),
	"slam": ([
		"action":		"$Nⴤ$wMSMra$n$lFLh",
		"damage_type":	"",
		"post_action":	(: call_other, __FILE__, "bash_weapon" :),
		]),
	"throw": ([
		"action":		"$NN$w$n$lgFLh",
		"damage_type":	"",
		"post_action":	(: call_other, __FILE__, "throw_weapon" :),
		]),
]);

varargs mapping query_action()
{
	string verb, *verbs;

	verbs = previous_object()->query("verbs");

	if( !pointerp(verbs) ) return weapon_actions["hit"];
	else {
		verb = verbs[random(sizeof(verbs))];
		if( !undefinedp(weapon_actions[verb]) ) return weapon_actions[verb];
		else return weapon_actions["hit"];
	}	
}

void throw_weapon(object me, object victim, object weapon, int damage)
{
	if( objectp(weapon) ) {
		if( (int)weapon->query_amount()==1 ) {
			weapon->unequip();
			tell_object(me, "\nA" + weapon->query("name") + "ΧFT\n\n");
		}
		weapon->add_amount(-1);
	}
}

void bash_weapon(object me, object victim, object weapon, int damage)
{
	object ob;
	int wap, wdp;

	if( objectp(weapon)
	&&	damage==RESULT_PARRY
	&&	ob = victim->query_temp("weapon") ) {
		wap = (int)weapon->weight() / 500
			+ (int)weapon->query("rigidity")
			+ (int)me->query("str");
		wdp = (int)ob->weight() / 500
			+ (int)ob->query("rigidity")
			+ (int)victim->query("str");
		wap = random(wap);
		if( wap > 2 * wdp ) {
			message_vision(HIW "$Nuıo⤤" + ob->name() + "wM⭸XT\n" NOR,
				victim);
			ob->unequip();
			ob->move(environment(victim));
			victim->reset_action();
		} else if( wap > wdp ) {
			message_vision("$Nuıo⤤" + ob->name() + "@_MIǲT\n",
				victim);
		} else if( wap > wdp / 2 ) {
			message_vision(HIW "uťuԡva@nM$N⤤" + ob->name()
				+ "wg_IT\n" NOR, victim );
			ob->unequip();
			ob->move(environment(victim));
			ob->set("name", "_" + ob->query("name"));
			ob->set("value", (int)ob->query("value") / 10);
			ob->set("weapon_prop", 0);
			victim->reset_action();
		} else {
			message_vision("$N" + weapon->name() + "M$n" + ob->name()
				+ "M_XIIPC\n", me, victim);
		}
	}
}
