// score.c

#include <ansi.h>
#include <combat.h>

string *gift_ranking = ({"UU","U", "U", "", "W", "W",
	"WW"});

inherit F_CLEAN_UP;

string gift_evaluation(int value);
string status_color(int current, int max);
string date_string(int date);

void create() { seteuid(ROOT_UID); }

int main(object me, string arg)
{
	object ob;
	mapping my;
	string line, str, skill_type;
	object weapon;
	int attack_points, dodge_points, parry_points;

	seteuid(getuid(me));

	if(!arg)
		ob = me;
	else if (wizardp(me)) {
		ob = present(arg, environment(me));
		if (!ob) ob = find_player(arg);
		if (!ob) ob = find_living(arg);
		if (!ob) return notify_fail("Anݽ֪AS\n");
	} else
		return notify_fail("uŮvݧOHAC\n");

	my = ob->query_entire_dbase();

	line = sprintf( BOLD "%s" NOR "%s\n\n", RANK_D->query_rank(ob), ob->short(1) );
	line += sprintf(" AO@%s%s%s%sM%s͡C\n\n",
		ob->query("unit"),
		chinese_number(ob->query("age")), 
		ob->query("gender"),
		ob->query("race"),
		CHINESE_D->chinese_date(((int)ob->query("birthday") - 14*365*24*60) * 60) );

	if( wizardp(me) || (int)ob->query("score") >= 100 ) {
		line += sprintf(
			" MOR%-8s  xѡR%-8s  ʡR%-8s  FʡR%-8s\n"
			" wOR%-8s  eR%-8s  ڰR%-8s  ֽtR%-8s\n\n",
			gift_evaluation(my["str"]), gift_evaluation(my["cor"]),
			gift_evaluation(my["int"]), gift_evaluation(my["spi"]),
			gift_evaluation(my["cps"]),	gift_evaluation(my["per"]),
			gift_evaluation(my["con"]),	gift_evaluation(my["kar"]));
	}

	if( mapp(my["family"]) ) {
		if( my["family"]["master_name"] )
			line = sprintf("%s AvO%sC\n\n",
				line, my["family"]["master_name"] );
	}

	line += sprintf(" R %s%4d/ %4d %s(%3d%%)" NOR "    FOR %s%4d / %4d (+%d)\n" NOR,
		status_color(my["gin"], my["eff_gin"]),	my["gin"],	my["eff_gin"],
		status_color(my["eff_gin"], my["max_gin"]),	my["eff_gin"] * 100 / my["max_gin"],
		status_color(my["atman"], my["max_atman"]),	my["atman"], my["max_atman"],
		my["atman_factor"] );
	line += sprintf(" R %s%4d/ %4d %s(%3d%%)" NOR "    OR %s%4d / %4d (+%d)\n" NOR,
		status_color(my["kee"], my["eff_kee"]),	my["kee"], my["eff_kee"],
		status_color(my["eff_kee"], my["max_kee"]),	my["eff_kee"] * 100 / my["max_kee"],
		status_color(my["force"], my["max_force"]),	my["force"], my["max_force"],
		my["force_factor"] );
	line += sprintf(" R %s%4d/ %4d %s(%3d%%)" NOR "    kOR %s%4d / %4d (+%d)\n" NOR,
		status_color(my["sen"], my["eff_sen"]),	my["sen"], my["eff_sen"],
		status_color(my["eff_sen"], my["max_sen"]),	my["eff_sen"] * 100 / my["max_sen"],
		status_color(my["mana"], my["max_mana"]), my["mana"], my["max_mana"],
		my["mana_factor"] );

	line += sprintf("\n Aثe`@F %d ӤHM䤤 %d ӬOLaC\n\n",
		my["MKS"] + my["PKS"], my["PKS"]);

	if( objectp(weapon = ob->query_temp("weapon")) )
		skill_type = weapon->query("skill_type");
	else
		skill_type = "unarmed";

	attack_points = COMBAT_D->skill_power(ob, skill_type, SKILL_USAGE_ATTACK);
	parry_points = COMBAT_D->skill_power(ob, skill_type, SKILL_USAGE_DEFENSE);
	dodge_points = COMBAT_D->skill_power(ob, "dodge", SKILL_USAGE_DEFENSE);

	line += sprintf("  ԰O " HIW "%d (+%d)" NOR "\t  ԰mO " HIW "%d (+%d)\n\n" NOR,
		attack_points/100 + 1, ob->query_temp("apply/damage"),
		(dodge_points + (weapon? parry_points: (parry_points/10)))/100 + 1, ob->query_temp("apply/armor"));
	line += sprintf("     R " RED "%d\n" NOR, ob->query("bellicosity") );
	line += sprintf("     R " HIY "%d (%d%%)\n" NOR,
		(int)ob->query("potential") - (int)ob->query("learned_points"),
		(1 + (int)ob->query("learned_points")) * 100 / (1 + (int)ob->query("potential")) );
	line += sprintf(" ԸgR " HIM "%d\n" NOR, ob->query("combat_exp") );
	line += sprintf(" XR " HIC "%d\n\n" NOR, ob->query("score") );

	write(line);
	return 1;
}

string gift_evaluation(int value)
{
	int ranking;

	ranking = (value - 10) / 3;
	if (ranking<0) ranking = 0;
	if (ranking>6) ranking = 6;
	return gift_ranking[ranking];
}

string status_color(int current, int max)
{
	int percent;

	if( max ) percent = current * 100 / max;
	else percent = 100;

	if( percent > 100 ) return HIC;
	if( percent >= 90 ) return HIG;
	if( percent >= 60 ) return HIY;
	if( percent >= 30 ) return YEL;
	if( percent >= 10 ) return HIR;
	return RED;
}

int help(object me)
{
	write(@HELP
O榡 : score
           score <HW>                   (ŮvM)

oӫOiHܧA(p)ΫwH(tǪ)򥻸ơC
򥻸ƪ]wаѾ\ 'help setup'C

FקKaFuѽvƭȦӤггyHM]wubXF
100 HWaΧŮv~ݱoѽ᪬pC

see also : hp
HELP
    );
    return 1;
}
